OpenTTD Source: src/spritecache.cpp File Reference

OpenTTD Source 14.0-beta3

Data Structures | Functions | Variables
spritecache.cpp File Reference
`#include "stdafx.h"`
`#include "random_access_file_type.h"`
`#include "spriteloader/grf.hpp"`
`#include "gfx_func.h"`
`#include "error.h"`
`#include "error_func.h"`
`#include "zoom_func.h"`
`#include "settings_type.h"`
`#include "blitter/factory.hpp"`
`#include "core/math_func.hpp"`
`#include "core/mem_func.hpp"`
`#include "video/video_driver.hpp"`
`#include "spritecache.h"`
`#include "spritecache_internal.h"`
`#include "table/sprites.h"`
`#include "table/strings.h"`
`#include "table/palette_convert.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
struct | MemBlock
struct | GrfSpriteOffset

## Functions
static SpriteCache * | GetSpriteCache (uint index)
SpriteCache * | AllocateSpriteCache (uint index)
static SpriteFile * | GetCachedSpriteFileByName (const std::string &filename)
| Get the cached SpriteFile given the name of the file. More...
SpriteFile & | OpenCachedSpriteFile (const std::string &filename, Subdirectory subdir, bool palette_remap)
| Open/get the SpriteFile that is cached for use in the sprite cache. More...
static void | CompactSpriteCache ()
| Called when holes in the sprite cache should be removed. More...
bool | SkipSpriteData (SpriteFile &file, byte type, uint16_t num)
| Skip the given amount of sprite graphics data. More...
bool | SpriteExists (SpriteID id)
SpriteType | GetSpriteType (SpriteID sprite)
| Get the sprite type of a given sprite. More...
SpriteFile * | GetOriginFile (SpriteID sprite)
| Get the SpriteFile of a given sprite. More...
uint32_t | GetSpriteLocalID (SpriteID sprite)
| Get the GRF-local sprite id of a given sprite. More...
uint | GetSpriteCountForFile (const std::string &filename, SpriteID begin, SpriteID end)
| Count the sprites which originate from a specific file in a range of SpriteIDs. More...
uint | GetMaxSpriteID ()
| Get a reasonable (upper bound) estimate of the maximum SpriteID used in OpenTTD; there will be no sprites with a higher SpriteID, although there might be up to roughly a thousand unused SpriteIDs below this number. More...
static bool | ResizeSpriteIn (SpriteLoader::SpriteCollection &sprite, ZoomLevel src, ZoomLevel tgt)
static void | ResizeSpriteOut (SpriteLoader::SpriteCollection &sprite, ZoomLevel zoom)
static bool | PadSingleSprite (SpriteLoader::Sprite *sprite, ZoomLevel zoom, uint pad_left, uint pad_top, uint pad_right, uint pad_bottom)
static bool | PadSprites (SpriteLoader::SpriteCollection &sprite, uint8_t sprite_avail, SpriteEncoder *encoder)
static bool | ResizeSprites (SpriteLoader::SpriteCollection &sprite, uint8_t sprite_avail, SpriteEncoder *encoder)
static void * | ReadRecolourSprite (SpriteFile &file, uint num)
| Load a recolour sprite into memory. More...
static void * | ReadSprite (const SpriteCache *sc, SpriteID id, SpriteType sprite_type, AllocatorProc *allocator, SpriteEncoder *encoder)
| Read a sprite from disk. More...
size_t | GetGRFSpriteOffset (uint32_t id)
| Get the file offset for a specific sprite in the sprite section of a GRF. More...
void | ReadGRFSpriteOffsets (SpriteFile &file)
| Parse the sprite section of GRFs. More...
bool | LoadNextSprite (int load_index, SpriteFile &file, uint file_sprite_id)
| Load a real or recolour sprite. More...
void | DupSprite (SpriteID old_spr, SpriteID new_spr)
static MemBlock * | NextBlock (MemBlock *block)
static size_t | GetSpriteCacheUsage ()
void | IncreaseSpriteLRU ()
static void | DeleteEntryFromSpriteCache (uint item)
| Delete a single entry from the sprite cache. More...
static void | DeleteEntryFromSpriteCache ()
void * | AllocSprite (size_t mem_req)
void * | SimpleSpriteAlloc (size_t size)
| Sprite allocator simply using malloc.
static void * | HandleInvalidSpriteRequest (SpriteID sprite, SpriteType requested, SpriteCache *sc, AllocatorProc *allocator)
| Handles the case when a sprite of different type is requested than is present in the SpriteCache. More...
void * | GetRawSprite (SpriteID sprite, SpriteType type, AllocatorProc *allocator, SpriteEncoder *encoder)
| Reads a sprite (from disk or sprite cache). More...
static void | GfxInitSpriteCache ()
void | GfxInitSpriteMem ()
void | GfxClearSpriteCache ()
| Remove all encoded sprites from the sprite cache without discarding sprite location information.
void | GfxClearFontSpriteCache ()
| Remove all encoded font sprites from the sprite cache without discarding sprite location information.

## Variables
uint | _sprite_cache_size = 4
static uint | _spritecache_items = 0
static SpriteCache * | _spritecache = nullptr
static std::vector< std::unique_ptr< SpriteFile > > | _sprite_files
static uint | _sprite_lru_counter
static MemBlock * | _spritecache_ptr
static uint | _allocated_sprite_cache_size = 0
static int | _compact_cache_counter
static std::map< uint32_t, GrfSpriteOffset > | _grf_sprite_offsets
| Map from sprite numbers to position in the GRF file.
static const size_t | S_FREE_MASK = sizeof(size_t) - 1
| S_FREE_MASK is used to mask-out lower bits of MemBlock::size If they are non-zero, the block is free. More...

## Detailed Description

Caching of sprites.

Definition in file spritecache.cpp.

## Function Documentation

## ◆ CompactSpriteCache()

static void CompactSpriteCache | ( |  | ) |
| static

Called when holes in the sprite cache should be removed.

That is accomplished by moving the cached data.

Definition at line 755 of file spritecache.cpp.

References Debug.

## ◆ DeleteEntryFromSpriteCache()

static void DeleteEntryFromSpriteCache | ( | uint | item | ) |
| static

Delete a single entry from the sprite cache.

Parameters

  item | Entry to delete.

Definition at line 799 of file spritecache.cpp.

## ◆ GetCachedSpriteFileByName()

static SpriteFile* GetCachedSpriteFileByName | ( | const std::string & | filename | ) |
| static

Get the cached SpriteFile given the name of the file.

Parameters

  filename | The name of the file at the disk.

Returns
  The SpriteFile or `null`.

Definition at line 67 of file spritecache.cpp.

Referenced by GetSpriteCountForFile(), and OpenCachedSpriteFile().

## ◆ GetGRFSpriteOffset()

size_t GetGRFSpriteOffset | ( | uint32_t | id | ) |

Get the file offset for a specific sprite in the sprite section of a GRF.

Parameters

  id | ID of the sprite to look up.

Returns
  Position of the sprite in the sprite section or SIZE_MAX if no such sprite is present.

Definition at line 544 of file spritecache.cpp.

References _grf_sprite_offsets.

## ◆ GetMaxSpriteID()

uint GetMaxSpriteID | ( |  | ) |

Get a reasonable (upper bound) estimate of the maximum SpriteID used in OpenTTD; there will be no sprites with a higher SpriteID, although there might be up to roughly a thousand unused SpriteIDs below this number.

Note
  It's actually the number of spritecache items.

Returns
  maximum SpriteID

Definition at line 211 of file spritecache.cpp.

Referenced by UpdateCursorSize().

## ◆ GetOriginFile()

SpriteFile* GetOriginFile | ( | SpriteID | sprite | ) |

Get the SpriteFile of a given sprite.

Parameters

  sprite | The sprite to look at.

Returns
  The SpriteFile.

Definition at line 161 of file spritecache.cpp.

## ◆ GetRawSprite()

void* GetRawSprite | ( | SpriteID | sprite,
|  | SpriteType | type,
|  | AllocatorProc * | allocator,
|  | SpriteEncoder * | encoder
| ) |  |

Reads a sprite (from disk or sprite cache).

If the sprite is not available or of wrong type, a fallback sprite is returned.

Parameters

  sprite | Sprite to read.
  type | Expected sprite type.
  allocator | Allocator function to use. Set to nullptr to use the usual sprite cache.
  encoder | Sprite encoder to use. Set to nullptr to use the currently active blitter.

Returns
  Sprite raw data

Definition at line 939 of file spritecache.cpp.

## ◆ GetSpriteCountForFile()

uint GetSpriteCountForFile | ( | const std::string & | filename,
|  | SpriteID | begin,
|  | SpriteID | end
| ) |  |

Count the sprites which originate from a specific file in a range of SpriteIDs.

Parameters

  file | The loaded SpriteFile.
  begin | First sprite in range.
  end | First sprite not in range.

Returns
  Number of sprites.

Definition at line 185 of file spritecache.cpp.

References GetCachedSpriteFileByName().

## ◆ GetSpriteLocalID()

uint32_t GetSpriteLocalID | ( | SpriteID | sprite | ) |

Get the GRF-local sprite id of a given sprite.

Parameters

  sprite | The sprite to look at.

Returns
  The GRF-local sprite id.

Definition at line 172 of file spritecache.cpp.

## ◆ GetSpriteType()

SpriteType GetSpriteType | ( | SpriteID | sprite | ) |

Get the sprite type of a given sprite.

Parameters

  sprite | The sprite to look at.

Returns
  the type of sprite.

Definition at line 150 of file spritecache.cpp.

## ◆ HandleInvalidSpriteRequest()

static void* HandleInvalidSpriteRequest | ( | SpriteID | sprite,
|  | SpriteType | requested,
|  | SpriteCache * | sc,
|  | AllocatorProc * | allocator
| ) |  |
| static

Handles the case when a sprite of different type is requested than is present in the SpriteCache.

For SpriteType::Font sprites, it is normal. In other cases, default sprite is loaded instead.

Parameters

  sprite | ID of loaded sprite
  requested | requested sprite type
  sc | the currently known sprite cache for the requested sprite

Returns
  fallback sprite

Note
  this function will do UserError() in the case the fallback sprite isn't available

Definition at line 894 of file spritecache.cpp.

## ◆ LoadNextSprite()

bool LoadNextSprite | ( | int | load_index,
|  | SpriteFile & | file,
|  | uint | file_sprite_id
| ) |  |

Load a real or recolour sprite.

Parameters

  load_index | Global sprite index.
  file | GRF to load from.
  file_sprite_id | Sprite number in the GRF.
  container_version | Container version of the GRF.

Returns
  True if a valid sprite was loaded, false on any error.

Definition at line 609 of file spritecache.cpp.

References _grf_sprite_offsets, SpriteFile::GetContainerVersion(), RandomAccessFile::GetPos(), Invalid, MAX_SPRITES, Normal, RandomAccessFile::ReadByte(), RandomAccessFile::ReadDword(), ReadRecolourSprite(), RandomAccessFile::ReadWord(), Recolour, RandomAccessFile::SkipBytes(), and SkipSpriteData().

## ◆ OpenCachedSpriteFile()

SpriteFile& OpenCachedSpriteFile | ( | const std::string & | filename,
|  | Subdirectory | subdir,
|  | bool | palette_remap
| ) |  |

Open/get the SpriteFile that is cached for use in the sprite cache.

Parameters

  filename | Name of the file at the disk.
  subdir | The sub directory to search this file in.
  palette_remap | Whether a palette remap needs to be performed for this file.

Returns
  The reference to the SpriteCache.

Definition at line 84 of file spritecache.cpp.

References GetCachedSpriteFileByName().

Referenced by LoadGrfFile(), and LoadGrfFileIndexed().

## ◆ ReadGRFSpriteOffsets()

void ReadGRFSpriteOffsets | ( | SpriteFile & | file | ) |

Parse the sprite section of GRFs.

Parameters

  container_version | Container version of the GRF we're currently processing.

Definition at line 553 of file spritecache.cpp.

References _grf_sprite_offsets, SpriteFile::GetContainerVersion(), RandomAccessFile::GetPos(), RandomAccessFile::ReadByte(), RandomAccessFile::ReadDword(), SCC_MASK, SCC_PAL, SCCF_ALLOW_ZOOM_MIN_1X_32BPP, SCCF_ALLOW_ZOOM_MIN_1X_PAL, SCCF_ALLOW_ZOOM_MIN_2X_32BPP, SCCF_ALLOW_ZOOM_MIN_2X_PAL, RandomAccessFile::SeekTo(), SetBit(), and RandomAccessFile::SkipBytes().

## ◆ ReadRecolourSprite()

static void* ReadRecolourSprite | ( | SpriteFile & | file,
|  | uint | num
| ) |  |
| static

Load a recolour sprite into memory.

Parameters

  file | GRF we're reading from.
  num | Size of the sprite in the GRF.

Returns
  Sprite data.

Definition at line 415 of file spritecache.cpp.

Referenced by LoadNextSprite().

## ◆ ReadSprite()

static void* ReadSprite | ( | const SpriteCache * | sc,
|  | SpriteID | id,
|  | SpriteType | sprite_type,
|  | AllocatorProc * | allocator,
|  | SpriteEncoder * | encoder
| ) |  |
| static

Read a sprite from disk.

Parameters

  sc | Location of sprite.
  id | Sprite number.
  sprite_type | Type of sprite.
  allocator | Allocator function to use.
  encoder | Sprite encoder to use.

Returns
  Read sprite data.

Definition at line 452 of file spritecache.cpp.

## ◆ SkipSpriteData()

bool SkipSpriteData | ( | SpriteFile & | file,
|  | byte | type,
|  | uint16_t | num
| ) |  |

Skip the given amount of sprite graphics data.

Parameters

  type | the type of sprite (compressed etc)
  num | the amount of sprites to skip

Returns
  true if the data could be correctly skipped.

Definition at line 113 of file spritecache.cpp.

Referenced by LoadNextSprite().

## Variable Documentation

## ◆ S_FREE_MASK

const size_t S_FREE_MASK = sizeof(size_t) - 1
| static

S_FREE_MASK is used to mask-out lower bits of MemBlock::size If they are non-zero, the block is free.

S_FREE_MASK has to ensure MemBlock is correctly aligned - it means 8B (S_FREE_MASK == 7) on 64bit systems!

Definition at line 698 of file spritecache.cpp.